<!-- -*-visual-line-*- -->

<div style="float:right">
  <a href="https://github.com/nasa/ziggy/">
    <img src="images/ziggy-small-clear.png" width="133"/>
  </a>
</div>

# Welcome to Ziggy!

Ziggy is "A Pipeline management system for Data Analysis Pipelines." This is the user guide and assorted documentation. 

## Table of Contents

1. [Super-Basic Introduction](../../README.md)

2. [Prerequisites and System Requirements](system-requirements.md)

3. [Pipeline Architecture](pipeline-architecture.md)

4. [Downloading and Building Ziggy](downloading-and-building-ziggy.md)

5. [Configuring a Pipeline](configuring-pipeline.md)

    5.1. [Module Parameters](module-parameters.md)

    5.2​. [Data File Types](data-file-types.md)

    5.3​. [Pipeline Definition](pipeline-definition.md)

6. [Building a Pipeline](building-pipeline.md)

7. [Setting up the Relational Database Management System (RDBMS)](rdbms.md)

8. [Running the Cluster](running-pipeline.md)

9. [Using the Ziggy Console, Part 1](ziggy-gui.md)

    9.1​. [Starting a Pipeline](start-pipeline.md)

    9.2​. [The Instances Panel](instances-panel.md)

    9.3.​ [Changing the Start and End Nodes](start-end-nodes.md)

    9.4.​ [Changing Module Parameter Values](change-param-values.md)

10. [Intermediate Topics](intermediate-topics.md)

    10.1. ​ [The Datastore and the Task Directory](datastore-task-dir.md)

    10.2​. [The Task Configuration Parameter Sets](task-configuration.md)

    10.3​. [The Properties File](properties.md)

11. [Troubleshooting Pipeline Execution](troubleshooting.md)

      11.1​. [Log Files in Ziggy](log-files.md)

12. [Using the Ziggy Console, Part 2: Troubleshooting](ziggy-gui-troubleshooting.md)

      12.1.​ [Monitoring Tab](monitoring.md)

      12.2.​ [Alerts Panel](alerts.md)

      12.3.​ [Log Files Display](display-logs.md)

      12.4.​ [Re-Run or Resume a Failed Task](rerun-task.md)

      12.5.​ [Deleting Tasks](delete-tasks.md)

13. [High Performance Computing](select-hpc.md)

      13.1​. [The Remote Execution Dialog Box](remote-dialog.md)

      13.2​. [HPC Cost Estimation](hpc-cost.md)

14. Cloud Computing (TBD)

15. [Data Receipt](data-receipt.md)

      15.1​. [Execution Flow](data-receipt-execution.md)

      15.2.​ [Console Display](data-receipt-display.md)

16. [Event Handler](event-handler.md)

      16.1​. [Introduction to Event Handlers](event-handler-intro.md)

      16.2​. [Defining Event Handlers](event-handler-definition.md)

      16.3​. [Event Handler Examples](event-handler-examples.md)

      16.4​. [Sending Event Information to Algorithms](event-handler-labels.md)

17. Reports and Performance Tracking (TBD) 

     <!--

      17.1​. [Memdrone](memdrone.md)

      17.2​. [Metrics](metrics.md)

      17.3​. [Instance Reports](instance-reports.md)

      17.4​. [Data Accountability](data-accountability.md) 

     -->

18. Alternative User Interface Options (TBD) 

     <!--

      18.1​. [Assistive Technologies](assistive-technologies.md)

      18.2​. [Mouse-Overs](mouse-overs.md)

      18.3​. [Console Appearance Control](appearance-control.md)

      18.1​. [Command Line Interface](console-cli.md)

     -->

19. Security (TBD)

20. [Ziggy's Dustier Corners](dusty-corners.md)

      20.1​. [More on the Relational Database](more-rdbms.md) 

      20.2​. [More on Parameter Sets](more-parameter-sets.md)

      20.3​. [Parameter Overrides](parameter-overrides.md)

      20.4​. [Redefining a Pipeline](redefine-pipeline.md)

      20.5​. [The Edit Trigger Dialog Box](edit-trigger.md)

21. [Contact Us](contact-us.md)
